"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = withNotify;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.set-prototype-of");

require("core-js/modules/es6.object.assign");

require("core-js/modules/web.dom.iterable");

var _react = _interopRequireWildcard(require("react"));

var _reactCommonKit = require("react-common-kit");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function withNotify() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var Trigger = config.trigger,
      _config$triggerProps = config.triggerProps,
      triggerProps = _config$triggerProps === void 0 ? {} : _config$triggerProps,
      _config$triggerPos = config.triggerPos,
      triggerPos = _config$triggerPos === void 0 ? 'top' : _config$triggerPos,
      onSuccess = config.onSuccess,
      onError = config.onError,
      _config$sourceStateNa = config.sourceStateName,
      sourceStateName = _config$sourceStateNa === void 0 ? 'source' : _config$sourceStateNa,
      _config$disbleErrorLo = config.disbleErrorLogger,
      disbleErrorLogger = _config$disbleErrorLo === void 0 ? false : _config$disbleErrorLo,
      _config$errorTexts = config.errorTexts,
      errorTexts = _config$errorTexts === void 0 ? {} : _config$errorTexts,
      filter = config.filter;
  return (0, _reactCommonKit.createHoc)(function (TargetComponent) {
    return (
      /*#__PURE__*/
      function (_Component) {
        _inherits(WithNotify, _Component);

        function WithNotify() {
          var _getPrototypeOf2;

          var _this;

          _classCallCheck(this, WithNotify);

          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(WithNotify)).call.apply(_getPrototypeOf2, [this].concat(args)));
          _this.trigger = (0, _react.createRef)();
          _this.state = {
            isPending: false,
            result: null,
            errors: [],
            hasNotify: false
          };
          return _this;
        }

        _createClass(WithNotify, [{
          key: "componentDidUpdate",
          value: function componentDidUpdate(_ref) {
            var _ref$sourceStateName = _ref[sourceStateName],
                isPending = _ref$sourceStateName.isPending,
                result = _ref$sourceStateName.result;
            var _this$props$sourceSta = this.props[sourceStateName],
                nextIsPending = _this$props$sourceSta.isPending,
                nextErrors = _this$props$sourceSta.errors,
                nextResult = _this$props$sourceSta.result;

            if (result !== null && filter && !filter(result, nextResult) || !(isPending && !nextIsPending)) {
              return;
            }

            if (nextErrors.length) {
              onError(this.trigger.current, nextErrors);

              if (nextErrors.length && !disbleErrorLogger && (typeof console === "undefined" ? "undefined" : _typeof(console)) === 'object' && console.error) {
                nextErrors.forEach(function (error) {
                  if (!errorTexts[error.message]) {
                    console.error("".concat(sourceStateName, " error:"), error.stack || error);
                  }
                });
              }
            } else {
              onSuccess(this.trigger.current);
            }
          }
        }, {
          key: "render",
          value: function render() {
            var passThroughProps = Object.assign({}, this.props);

            var trigger = Trigger && _react.default.createElement(Trigger, _extends({
              ref: this.trigger
            }, triggerProps));

            return _react.default.createElement("div", null, triggerPos === 'top' && trigger, _react.default.createElement(TargetComponent, passThroughProps), triggerPos === 'bottom' && trigger);
          }
        }]);

        return WithNotify;
      }(_react.Component)
    );
  });
}

module.exports = exports["default"];